export declare type PropertyAnnotation = (target: {
    constructor: any;
}, paramName: string) => void;
export interface ENV {
    (envVarName: string): PropertyAnnotation;
    (envVarName: string, required: boolean): PropertyAnnotation;
    (envVarName: string, type: 'number' | 'boolean'): PropertyAnnotation;
    (envVarName: string, type: 'number' | 'boolean', required: boolean): PropertyAnnotation;
    (envVarName: string, transform: (envVariable: string) => any): PropertyAnnotation;
    (envVarName: string, transform: (envVariable: string) => any, required: boolean): PropertyAnnotation;
}
export declare function ENV(envVarName: string, param2?: ((envVariable: string) => any) | boolean | 'number' | 'boolean', param3?: boolean): (target: {
    constructor: any;
}, paramName: string) => void;
export interface CLI {
    (cliVarName: string): PropertyAnnotation;
    (cliVarName: string, required: boolean): PropertyAnnotation;
    (cliVarName: string, type: 'number' | 'boolean'): PropertyAnnotation;
    (cliVarName: string, type: 'number' | 'boolean', required: boolean): PropertyAnnotation;
    (cliVarName: string, transform: (envVariable: string) => any): PropertyAnnotation;
    (cliVarName: string, transform: (envVariable: string) => any, required: boolean): PropertyAnnotation;
}
export declare function CLI(cliVarName: string, param2?: ((envVariable: string) => any) | boolean | 'number' | 'boolean', param3?: boolean): (target: {
    constructor: any;
}, paramName: string) => void;
export declare function loadConfig<T>(Type: {
    new (): T;
}): T;
